VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4860
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9630
   LinkTopic       =   "Form1"
   ScaleHeight     =   4860
   ScaleWidth      =   9630
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command3 
      Caption         =   "Call Method 1 Pointer"
      Height          =   330
      Left            =   4995
      TabIndex        =   3
      Top             =   2970
      Width           =   3120
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Call Method 1 normal"
      Height          =   285
      Left            =   405
      TabIndex        =   2
      Top             =   3015
      Width           =   2490
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   8640
      Top             =   1080
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Copy"
      Height          =   330
      Left            =   8370
      TabIndex        =   1
      Top             =   405
      Width           =   1095
   End
   Begin VB.ListBox List1 
      BeginProperty Font 
         Name            =   "System"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2700
      Left            =   360
      TabIndex        =   0
      Top             =   180
      Width           =   7755
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" ( _
    ByVal lpPrevWndFunc As Long, _
    ByVal hwnd As Long, _
    ByVal msg As Long, _
    ByVal wParam As Long, _
    ByVal lParam As Long _
) As Long


Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    pDest As Any, _
    pSrc As Any, _
    ByVal ByteLen As Long _
)


Private Declare Function htonl Lib "ws2_32.dll" (ByVal hostlong As Long) As Long


Dim c As New Class1
Dim method1_raw_address As Long



Private Sub Command1_Click()
    Dim tmp As String, i As Long
    For i = 0 To List1.ListCount
        tmp = tmp & List1.List(i) & vbCrLf
    Next
    Clipboard.Clear
    Clipboard.SetText tmp
End Sub

Private Sub Command2_Click()
    c.Method1 &HAAAAAAAA, &HBBBBBBBB
End Sub

Private Sub Command3_Click()
    Dim this As Long
    Dim retVal As Long
    this = ObjPtr(c)
    CallWindowProc method1_raw_address, this, &HAAAAAAAA, &HBBBBBBBB, VarPtr(retVal)
    MsgBox "Method 1 returned: " & Hex(retVal)
End Sub

Private Sub Form_Load()
    Timer1.Enabled = True
End Sub


Private Sub Timer1_Timer()
    
    Timer1.Enabled = False
    
    If IsIde() Then
        List1.AddItem "This can not be run in the IDE."
        List1.AddItem "the memory layout is not that of a compiled C++ class"
        List1.AddItem "Its probably using pcode when in IDE"
        Exit Sub
    End If
    
    List1.AddItem "Address of obj is: 0x" & Hex(ObjPtr(c))
    
    Dim offset As Long
    Dim entry As Long
    Dim v As Long
    
    offset = ReadLong(ObjPtr(c))
    List1.AddItem "VTable for object is at 0x" & Hex(offset)
    
    entry = offset + (7 * 4)
    List1.AddItem "First user entry at 0x" & Hex(entry)
    
    Dim funcs() As Long
    Do
        v = ReadLong(entry)
        If v <> 0 Then
            push funcs, v
            entry = entry + 4
            List1.AddItem "    " & Hex(entry) & " = " & Hex(v)
        End If
    Loop While v <> 0
    
    List1.AddItem "Found " & UBound(funcs) + 1 & " user functions"
    
    Dim i As Long, b As Byte
    Dim addresses() As Long
    Dim calc_addr() As Long
    
    For i = 0 To UBound(funcs)
        b = ReadByte(funcs(i))
        If b = &HE9 Then 'its a jmp as expected
           push addresses, ReadLong(funcs(i) + 1)
        Else
           List1.AddItem "Func: " & i & " NOT a JMP"
           Exit Sub
        End If
    Next
    
    ReDim calc_addr(UBound(addresses))
    For i = 0 To UBound(addresses)
        calc_addr(i) = funcs(i) + addresses(i) + 5 '5 = length of relative jump instruction
        List1.AddItem "Func: " & i & " = " & Hex(addresses(i)) & " -> " & Hex(calc_addr(i))
    Next
    
    Dim buf() As Byte
    Dim s As String
    
    For i = 0 To UBound(calc_addr)
        buf() = ReadBuf(calc_addr(i), 150)
        s = StrConv(buf, vbUnicode)
        If InStr(s, Chr(&H44) & Chr(&H33) & Chr(&H22) & Chr(&H11)) > 0 Then
            method1_raw_address = calc_addr(i)
            List1.AddItem " Found Marker in function: " & i & " at " & Hex(calc_addr(i))
            Exit For
        End If
    Next
    
    
End Sub


Function ReadBuf(offset As Long, sz As Long) As Byte()
    Dim b() As Byte
    ReDim b(sz)
    CopyMemory b(0), ByVal offset, sz
    ReadBuf = b()
End Function

Function ReadLong(offset As Long) As Long
    Dim tmp As Long
    CopyMemory ByVal VarPtr(tmp), ByVal offset, 4
    ReadLong = tmp
End Function

Function ReadByte(offset As Long) As Byte
    Dim tmp As Byte
    CopyMemory ByVal VarPtr(tmp), ByVal offset, 1
    ReadByte = tmp
End Function


Sub push(ary, value) 'this modifies parent ary object
    On Error GoTo init
    x = UBound(ary) '<-throws Error If Not initalized
    ReDim Preserve ary(UBound(ary) + 1)
    ary(UBound(ary)) = value
    Exit Sub
init:     ReDim ary(0): ary(0) = value
End Sub



Function IsIde() As Boolean
' Brad Martinez  http://www.mvps.org/ccrp
    On Error GoTo out
    Debug.Print 1 / 0
out: IsIde = Err
End Function



 
